Public Member Functions
CICEAttributeDataArray2DCustomType Class Reference

## Detailed Description

This class is a specialization of CICEAttributeDataArray to give access to the ICEAttribute data as a 2D array of type siICENodeDataCustomType. CICEAttributeDataArray2DCustomType objects are read-only and can be filled with the methods supplied with the ICEAttribute class.

Note:
  Data of type siICENodeDataCustomType can be created with custom ICENodes.

See also:
  ICEAttribute::GetDataArray2D, ICEAttribute::GetDataArray2DChunk, CICEAttributeDataArrayCustomType, Type Definitions for CICEAttributeDataArray

Since:
  Supernova

Example:
  This example demonstrates how to iterate over the siICENodeDataCustomType 2D attributes on a geometry. Check out the SDK InspectICEAttributes sample for a more detailed example.

              using namespace XSI;

              Application app;
              X3DObject x3dObj = app.GetSelection().GetItem(0);
              ICEAttribute attr = x3dObj.GetActivePrimitive().GetGeometry().GetICEAttributeFromName( L"SomeCustomDataType2DAttribute" );

              // Log the data pointer address and size of data.
              CICEAttributeDataArray2DCustomType customData2D;

              attr.GetDataArray2D( customData2D );

              for( ULONG i=0; i<customData2D.GetCount( ); i++ )
              {
                  CICEAttributeDataArrayCustomType customData;
                  customData2D.GetSubArray( i, customData );
                  for( ULONG j=0; j<customData.GetCount( ); j++ )
                  {
                      ULONG nSize;
                      const CICEAttributeDataArrayCustomType::TData* pBuffer;
                      customData.GetData( j, &pBuffer, nSize );

                      app.LogMessage( CString( (void*)pBuffer ) + L":" + CString( nSize ) );
                  }
              }

`#include <xsi_iceattributedataarray2D.h>`

Inheritance diagram for CICEAttributeDataArray2DCustomType:
[legend]

List of all members.

## Public Member Functions
| CICEAttributeDataArray2DCustomType ()
| ~CICEAttributeDataArray2DCustomType ()
CStatus | GetSubArray (ULONG in_index, CBaseICEAttributeDataArray &out_dataArray) const

## Constructor & Destructor Documentation

CICEAttributeDataArray2DCustomType | ( |  | ) | `[inline]`

Constructor.

~CICEAttributeDataArray2DCustomType | ( |  | ) | `[inline]`

Destructor.

## Member Function Documentation

CStatus GetSubArray | ( | ULONG | in_index,
|  | CBaseICEAttributeDataArray & | out_dataArray
| ) |  | const `[inline]`

Returns the sub-array containing the custom type data at a given index.

Parameters:

  in_index | Index in the array. The index must be smaller than the number of elements in the array, otherwise the results are unpredictable.
  out_dataArray | A read-only reference to a `CICEAttributeDataArrayCustomType` object at a specific index.

Returns:
  CStatus::OK Success
  CStatus::InvalidArgument If `in_index` or `out_dataArray` is invalid.

The documentation for this class was generated from the following file:

- xsi_iceattributedataarray2D.h